Index: trunk/docs/examples/_config.inc.php
===================================================================
--- trunk/docs/examples/_config.inc.php	(revision 664)
+++ trunk/docs/examples/_config.inc.php	(revision 665)
@@ -96,5 +96,5 @@
 ));
 
-if ($app->cli) {
+if ($app->isCLI()) {
     // DB credentials for command line scripts stored in a file with read rights
     // given only to the user who will be executing the scripts: -rw-------
Index: trunk/lib/App.inc.php
===================================================================
--- trunk/lib/App.inc.php	(revision 664)
+++ trunk/lib/App.inc.php	(revision 665)
@@ -594,4 +594,14 @@
     }
 
+    /*
+    * @access   public
+    * @return   bool    True if running in the context of a CLI script.
+    * @author   Quinn Comendant <quinn@strangecode.com>
+    * @since    10 Feb 2019 12:31:59
+    */
+    public function isCLI()
+    {
+        return $this->cli;
+    }
 
     /**
Index: trunk/lib/DB.inc.php
===================================================================
--- trunk/lib/DB.inc.php	(revision 664)
+++ trunk/lib/DB.inc.php	(revision 665)
@@ -261,5 +261,5 @@
 
         if ($this->getParam('db_die_on_failure')) {
-            if (!$app->cli) {
+            if (!$app->isCLI()) {
                 // For http requests, send a Service Unavailable header.
                 header(' ', true, 503);
@@ -357,5 +357,5 @@
             $app->logMsg(sprintf('MySQL error %s: %s in query: %s', mysql_errno($this->dbh), mysql_error($this->dbh), $debugqry), LOG_EMERG, __FILE__, __LINE__);
             if ($this->getParam('db_debug')) {
-                if (!$app->cli) {
+                if (!$app->isCLI()) {
                     echo '<pre style="padding:2em; background:#ddd; font:9px monaco;">' . wordwrap(mysql_error($this->dbh)) . '<hr>' . htmlspecialchars($debugqry) . '</pre>';
                 }
Index: trunk/lib/FormValidator.inc.php
===================================================================
--- trunk/lib/FormValidator.inc.php	(revision 664)
+++ trunk/lib/FormValidator.inc.php	(revision 665)
@@ -364,4 +364,5 @@
     * @param  string $form_name the name of the incoming form variable
     * @param  string $msg       the message to display on error
+    * @param  bool   $negative_ok   Set to true if negative numbers will be allowed.
     * @param  const  $type  A LOG_* constant (see App->logMsg())
     * @param  const  $file  Filename to log (usually __FILE__)
Index: trunk/lib/Prefs.inc.php
===================================================================
--- trunk/lib/Prefs.inc.php	(revision 664)
+++ trunk/lib/Prefs.inc.php	(revision 665)
@@ -178,8 +178,8 @@
 
         // CLI scripts can't use prefs stored in HTTP-based protocols.
-        if ($app->cli
+        if ($app->isCLI()
         && isset($params['storagetype'])
         && in_array($params['storagetype'], array('cookie', 'session'))) {
-            $app->logMsg(sprintf('Storage type %s not available for CLI', $params['storagetype']), LOG_NOTICE, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Storage type %s not available for CLI', $params['storagetype']), LOG_DEBUG, __FILE__, __LINE__);
         }
 
@@ -503,5 +503,5 @@
         // Skip this method if not using the db.
         if ('database' != $this->getParam('storagetype')) {
-            $app->logMsg('Prefs->load() does nothing unless using a database storagetype.', LOG_NOTICE, __FILE__, __LINE__);
+            $app->logMsg('Prefs->load() does nothing unless using a database storagetype.', LOG_DEBUG, __FILE__, __LINE__);
             return true;
         }
@@ -559,5 +559,5 @@
     {
         if ('database' != $this->getParam('storagetype')) {
-            $app->logMsg('Prefs->_isLoaded() does nothing unless using a database storagetype.', LOG_NOTICE, __FILE__, __LINE__);
+            $app->logMsg('Prefs->_isLoaded() does nothing unless using a database storagetype.', LOG_DEBUG, __FILE__, __LINE__);
             return true;
         }
Index: trunk/lib/Utilities.inc.php
===================================================================
--- trunk/lib/Utilities.inc.php	(revision 664)
+++ trunk/lib/Utilities.inc.php	(revision 665)
@@ -42,5 +42,5 @@
     $app =& App::getInstance();
 
-    if ($app->cli) {
+    if ($app->isCLI()) {
         echo "DUMP FROM: $file $line\n";
     } else {
@@ -76,5 +76,5 @@
     }
 
-    if ($app->cli) {
+    if ($app->isCLI()) {
         echo "\n";
     } else {