Index: branches/1.1dev/lib/Nav.inc.php
===================================================================
--- branches/1.1dev/lib/Nav.inc.php	(revision 678)
+++ branches/1.1dev/lib/Nav.inc.php	(revision 680)
@@ -3,5 +3,5 @@
  * The Nav:: class provides a system for working with navigation elements.
  * Currently it supports storing page titles and URLs for printing breadcrumbs
- * and titles, as well as setting page features such as hiding the page title on 
+ * and titles, as well as setting page features such as hiding the page title on
  * some pages but not others.
  *
@@ -74,14 +74,14 @@
     {
         if (isset($title)) {
-            $this->pages[sizeof($this->pages)-1]['title'] = $title;            
+            $this->pages[sizeof($this->pages)-1]['title'] = $title;
         }
         if (isset($url)) {
-            $this->pages[sizeof($this->pages)-1]['url'] = $url;            
+            $this->pages[sizeof($this->pages)-1]['url'] = $url;
         }
         if (isset($features) && is_array($features)) {
-            $this->pages[sizeof($this->pages)-1]['features'] = array_merge($this->pages[sizeof($this->pages)-1]['features'], $features);            
-        }
-    }
-    
+            $this->pages[sizeof($this->pages)-1]['features'] = array_merge($this->pages[sizeof($this->pages)-1]['features'], $features);
+        }
+    }
+
     /**
      * Set the features of the current page. Future versions of this class
@@ -100,10 +100,10 @@
         	$page_id = sizeof($this->pages) + intval($page_id);
         }
-        
+
         if (!isset($this->pages[sizeof($this->pages)-1]['features']) || !isset($this->pages[$page_id]['features'])) {
             $app->logMsg(sprintf('Page not available to set feature: page_id = %s', $page_id), LOG_ERR, __FILE__, __LINE__);
             return false;
         }
-        
+
         if (isset($features) && is_array($features)) {
             // Set features for specified page.
@@ -128,5 +128,5 @@
  * OUTPUT
  *****************************************************************************/
- 
+
     /**
      * Get the value of a feature for specified page_id or current page if page_id not specified (future use).
@@ -144,16 +144,15 @@
         	$page_id = sizeof($this->pages) + intval($page_id);
         }
-        
+
         switch ($feature) {
         case 'breadcrumbs' :
             // No breadcrumbs if displayed quantity of crumbs is less than 1.
-            return $this->pages[$page_id]['features'][$feature] && ((sizeof($this->pages) - $this->getFeature('chop_breadcrumbs')) > 0);
-            break;
+            return isset($this->pages[$page_id]['features'][$feature]) && $this->pages[$page_id]['features'][$feature] && ((sizeof($this->pages) - $this->getFeature('chop_breadcrumbs')) > 0);
         default :
-            return $this->pages[$page_id]['features'][$feature];
-        }
-    }
-
-        
+            return isset($this->pages[$page_id]['features'][$feature]) ? $this->pages[$page_id]['features'][$feature] : '';
+        }
+    }
+
+
     /**
      * Returns the title of current page.
@@ -170,5 +169,5 @@
         	$page_id = sizeof($this->pages) + intval($page_id);
         }
-        
+
         if ($this->getFeature('title', $page_id)) {
             return oTxt($this->pages[$page_id]['title'], true);
@@ -203,5 +202,5 @@
         	$page_id = sizeof($this->pages) + intval($page_id);
         }
-        
+
         if ($this->getFeature('path', $page_id)) {
             $path = '';
@@ -246,5 +245,5 @@
         	$page_id = sizeof($this->pages) + intval($page_id);
         }
-        
+
         if ($this->getFeature('breadcrumbs')) {
             $breadcrumbs = '';
@@ -276,5 +275,5 @@
                 $pathmark = $this->path_delimiter;
                 $crumb_count--;
-                
+
                 if ($curr_id === $page_id) {
                     // Reached requested page.
@@ -297,5 +296,5 @@
         echo $this->getBreadcrumbs($page_id);
     }
-    
+
     /**
      * Returns a string if the queried page is the current page. One use is to print
@@ -316,6 +315,6 @@
         }
     }
-    
-} 
+
+}
 // End of class.
 