Index: trunk/bin/user.cli.php
===================================================================
--- trunk/bin/user.cli.php	(revision 694)
+++ trunk/bin/user.cli.php	(revision 695)
@@ -61,10 +61,10 @@
 }
 
-if (!isset($db) || !is_a($db, 'DB')) {
+if (!isset($db) || !($db instanceof \DB)) {
     echo "This project doesn't have a \$db object.\n";
     exit(1);
 }
 
-if (!isset($auth) || !is_a($auth, 'Auth_SQL')) {
+if (!isset($auth) || !($auth instanceof \Auth_SQL)) {
     echo "This project doesn't have an \$auth object.\n";
     exit(1);
Index: trunk/services/css.php
===================================================================
--- trunk/services/css.php	(revision 694)
+++ trunk/services/css.php	(revision 695)
@@ -28,5 +28,5 @@
  * ever modify this file.
  */
-if (is_a($css, 'CSS')) {
+if ($css instanceof \CSS) {
     $css->headers(getFormData('app'));
     $css->output(getFormData('app'));
Index: trunk/services/js.php
===================================================================
--- trunk/services/js.php	(revision 694)
+++ trunk/services/js.php	(revision 695)
@@ -28,5 +28,5 @@
  * ever modify this file.
  */
-if (is_a($js, 'JS')) {
+if ($js instanceof \JS) {
     $js->headers(getFormData('app'));
     $js->output(getFormData('app'));
Index: trunk/services/lock.php
===================================================================
--- trunk/services/lock.php	(revision 694)
+++ trunk/services/lock.php	(revision 695)
@@ -46,5 +46,5 @@
 }
 
-if (!isset($lock) || !is_a($lock, 'Lock')) {
+if (!isset($lock) || !($lock instanceof \Lock)) {
     $lock =& Lock::getInstance($auth);
 }
Index: trunk/services/templates/lock.ihtml
===================================================================
--- trunk/services/templates/lock.ihtml	(revision 694)
+++ trunk/services/templates/lock.ihtml	(revision 695)
@@ -1,4 +1,4 @@
 <?php
-if (!is_a($lock, 'Lock')) {
+if (!($lock instanceof \Lock)) {
     // If the Lock object hasn't been instantiated, don't execute this template.
     return null;
Index: trunk/services/versions.php
===================================================================
--- trunk/services/versions.php	(revision 694)
+++ trunk/services/versions.php	(revision 695)
@@ -107,5 +107,5 @@
 
 case 'restore' :
-    if (!isset($lock) || !is_a($lock, 'Lock')) {
+    if (!isset($lock) || !($lock instanceof \Lock)) {
         $lock =& Lock::getInstance($auth);
     }
Index: trunk/tests/LockTest.php
===================================================================
--- trunk/tests/LockTest.php	(revision 694)
+++ trunk/tests/LockTest.php	(revision 695)
@@ -102,5 +102,5 @@
     {
         $result = Lock::getinstance($this->Auth_SQL);
-        $this->assertTrue($result && is_a($result, 'Lock'));
+        $this->assertTrue($result && $result instanceof \Lock);
     }
 
Index: trunk/tests/VersionTest.php
===================================================================
--- trunk/tests/VersionTest.php	(revision 694)
+++ trunk/tests/VersionTest.php	(revision 695)
@@ -4,5 +4,5 @@
  * For details visit the project site: <http://trac.strangecode.com/codebase/>
  * Copyright 2001-2012 Strangecode, LLC
- * 
+ *
  * This file is part of The Strangecode Codebase.
  *
@@ -11,10 +11,10 @@
  * Free Software Foundation, either version 3 of the License, or (at your option)
  * any later version.
- * 
+ *
  * The Strangecode Codebase is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
  * details.
- * 
+ *
  * You should have received a copy of the GNU General Public License along with
  * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
@@ -37,5 +37,5 @@
 
     function setUp()
-    {   
+    {
         require dirname(__FILE__) . '/_config.inc.php';
         require_once '../lib/Version.inc.php';
@@ -84,5 +84,5 @@
     {
         $db =& DB::getInstance();
-    
+
         unset($this->Version);
         unset($this->Auth_SQL);
@@ -95,5 +95,5 @@
     {
         $result = Version::getinstance($this->Auth_SQL);
-        $this->assertTrue($result && is_a($result, 'Version'));
+        $this->assertTrue($result && $result instanceof Version);
     }
 